<?php

class WPML_ST_Upgrade_Db_Cache_Command extends WPML_WPDB_User implements IWPML_St_Upgrade_Command {
	/**
	 * @var string
	 */
	private $sql = '
	CREATE TABLE IF NOT EXISTS `%sicl_string_pages` (
		  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
		  `string_id` bigint(20) NOT NULL,
		  `language` varchar(5) NOT NULL,
		  `url` varchar(255) NULL,
		  PRIMARY KEY (`id`),
		  KEY `string_id` (`string_id`),
		  KEY `string_pages_lang_url` (`language`,`url`(191)),
		  UNIQUE  KEY `string_string_pages_lang_url` (`string_id`,`language`,`url`(191))
		)
	';

	/**
	 * @param WPDB $wpdb
	 */
	public function __construct( WPDB $wpdb ) {
		parent::__construct( $wpdb );

		$charset_collate = $this->get_charset_collate();
		$this->sql = sprintf( $this->sql, $this->wpdb->prefix );
		$this->sql .= $charset_collate;
	}


	public function run() {
		return false !== $this->wpdb->query( $this->sql );
	}

	public function run_ajax() {
	}

	public function run_frontend() {
	}

	/**
	 * @return string
	 */
	private function get_charset_collate() {
		$charset_collate = '';
		if ( method_exists( $this->wpdb, 'has_cap' ) && $this->wpdb->has_cap( 'collation' ) ) {
			$charset_collate = $this->wpdb->get_charset_collate();
		}

		return $charset_collate;
	}
}